declare type Leaf = BigInt;
interface Queue {
    levels: BigInt[][];
    indices: number[];
}
declare class AccQueue {
    private MAX_DEPTH;
    subDepth: number;
    hashLength: number;
    zeroValue: BigInt;
    currentSubtreeIndex: number;
    subHashFunc: (leaves: Leaf[]) => BigInt;
    hashFunc: (leaves: Leaf[]) => BigInt;
    numLeaves: number;
    leafQueue: Queue;
    nextSRindexToQueue: number;
    smallSRTroot: BigInt;
    subRootQueue: Queue;
    subRoots: BigInt[];
    mainRoots: BigInt[];
    zeros: BigInt[];
    subTreesMerged: boolean;
    constructor(_subDepth: number, _hashLength: number, _zeroValue: BigInt);
    getSubRoot(_index: number): BigInt;
    enqueue(_leaf: Leaf): number;
    private _enqueue;
    fill(): void;
    private _fill;
    calcSRTdepth(): number;
    insertSubTree(_subRoot: BigInt): void;
    merge(_depth: number): void;
    mergeDirect(_depth: number): void;
    mergeSubRoots(_numSrQueueOps?: number): void;
    private queueSubRoot;
    getRoot(_depth: number): BigInt;
    hasRoot(_depth: number): boolean;
    copy(): AccQueue;
    hash(_leaves: BigInt[]): BigInt;
}
export { AccQueue, };
