/// <reference types="node" />
import { AccQueue } from './AccQueue';
import { OptimisedMT as IncrementalQuinTree } from 'optimisedmt';
declare const stringifyBigInts: (obj: object) => any;
declare const unstringifyBigInts: (obj: object) => any;
declare type SnarkBigInt = BigInt;
declare type PrivKey = BigInt;
declare type PubKey = BigInt[];
declare type EcdhSharedKey = BigInt[];
declare type Plaintext = BigInt[];
declare type Ciphertext = BigInt[];
declare class G1Point {
    x: BigInt;
    y: BigInt;
    constructor(_x: BigInt, _y: BigInt);
    equals(pt: G1Point): boolean;
    asContractParam(): {
        x: string;
        y: string;
    };
}
declare class G2Point {
    x: BigInt[];
    y: BigInt[];
    constructor(_x: BigInt[], _y: BigInt[]);
    equals(pt: G2Point): boolean;
    asContractParam(): {
        x: string[];
        y: string[];
    };
}
interface Keypair {
    privKey: PrivKey;
    pubKey: PubKey;
}
interface Signature {
    R8: BigInt[];
    S: BigInt;
}
declare const SNARK_FIELD_SIZE: bigint;
declare const NOTHING_UP_MY_SLEEVE: bigint;
declare const bigInt2Buffer: (i: BigInt) => Buffer;
declare const sha256Hash: (input: BigInt[]) => bigint;
declare const hash2: (elements: Plaintext) => BigInt;
declare const hash3: (elements: Plaintext) => BigInt;
declare const hash4: (elements: Plaintext) => BigInt;
declare const hash5: (elements: Plaintext) => BigInt;
declare const hash13: (elements: Plaintext) => BigInt;
declare const hashOne: (preImage: BigInt) => BigInt;
declare const hashLeftRight: (left: BigInt, right: BigInt) => BigInt;
declare const genPrivKey: () => PrivKey;
declare const genRandomSalt: () => PrivKey;
declare const formatPrivKeyForBabyJub: (privKey: PrivKey) => any;
declare const packPubKey: (pubKey: PubKey) => Buffer;
declare const unpackPubKey: (packed: Buffer) => PubKey;
declare const genPubKey: (privKey: PrivKey) => PubKey;
declare const genKeypair: () => Keypair;
declare const genEcdhSharedKey: (privKey: PrivKey, pubKey: PubKey) => EcdhSharedKey;
declare const encrypt: (plaintext: Plaintext, sharedKey: EcdhSharedKey, nonce?: bigint) => Ciphertext;
declare const decrypt: (ciphertext: Ciphertext, sharedKey: EcdhSharedKey, nonce: BigInt, length: number) => Plaintext;
declare const sign: (privKey: PrivKey, msg: BigInt) => Signature;
declare const verifySignature: (msg: BigInt, signature: Signature, pubKey: PubKey) => boolean;
export { genRandomSalt, genPrivKey, genPubKey, genKeypair, genEcdhSharedKey, encrypt, decrypt, sign, sha256Hash, hashOne, hash2, hash3, hash4, hash5, hash13, hashLeftRight, verifySignature, Signature, PrivKey, PubKey, G1Point, G2Point, Keypair, EcdhSharedKey, Ciphertext, Plaintext, SnarkBigInt, stringifyBigInts, unstringifyBigInts, formatPrivKeyForBabyJub, IncrementalQuinTree, AccQueue, NOTHING_UP_MY_SLEEVE, SNARK_FIELD_SIZE, bigInt2Buffer, packPubKey, unpackPubKey, };
